import xbmcplugin
import xbmcgui
import sys
import urllib, urllib2
import time
import re
from htmlentitydefs import name2codepoint as n2cp

thisPlugin = int(sys.argv[1])

urlHost = "http://www.voxnow.de"
ajaxUrl = "/xajaxuri.php"
# -----regexContent-------
# [0] is url (/foo.php)
# [1] is name (foo is bar)
# ------------------------
# -----regexSeries--------
# [0] is class even or odd 
# [1] is url to videourl
# [2] is title
# [3] is time
# All content is in!
# the free-content will be filtered in code (paytype)

n_regexContent = '<div class="m03medium".*?<div class="m03img">.*?<img.*?src="([^"]+)">.*?<div class="m03text"[^>]*?>.*?<span class="m03date">(FREE|PAY|PRE-TV).*?<h2>(.*?)</h2>(.*?)</div>.*?<div class="m03link">.*?href="([^"]+)" target="_self"([^>]?)>.*?</div>'
regexContent = '<div class="seriennavi_free" style=""><a href="(.*?)".*?>FREE.*?</div>.*?<div style="" class="seriennavi_link">.*?">(.*?)</a>.*?</div>'
regexSeries = '<div class="line (even|odd) "><div onclick="link\(\'(.*?)\'\); return false;".*?<a href=".*?" title=".*?">(.*?)</a>.*?class="time">.*?<div.*?</div>(.*?)</div>.*?class="minibutton">(.*?)</a></div></div>'
n_regexMeta = '<meta property="og:description" content="([^"]+)">.*?<meta property="og:image" content="([^"]+)">'
regexVideoData = "data:'(.*?)'"
regexF4mVideo = "http://.*?videos/(.*?).f4m\?ts.*?"
regexBiggerPic = "(.*?)(\d{3}x\d{3})([^\d]{1})(.*)"
regexXML = '<filename.*?><!\[CDATA\[(.*?)\]\]></filename>'
regexTextOnly = '<\s*\/?\s*\s*.*?>'
regexTabVars = '<select\s*?onchange.*?xajax_show_top_and_movies.*?\'(.*?)\'.*?\'(.*?)\'.*?\'(.*?)\'.*?\'(.*?)\'.*?\'(.*?)\'.*?>(.*?)</select>'
regexTabEntry = '<option.*?value=\'(\d)\'.*?>'
pageUrlRegex = 'property="og:url" content="http:\/\/www.voxnow.de\/(.*?)">'
# ------------------------

def showContent():
	global thisPlugin

	content = getUrl(urlHost+"/sendung_a_z.php")
	match = re.compile(n_regexContent,re.DOTALL).findall(content)
	for m in match:
		if m[1]=="FREE":
			print "[phr] -- picUrl: "+m[0]
			pictureUrl = returnBiggerPic(m[0])
			print "[phr] -- converted pictureUrl: "+pictureUrl
			
			addDirectoryItem(m[2].strip(), {"urlS": "/"+m[4]},pictureUrl)  
			print m
	print "--- showContent ok"	
	xbmcplugin.endOfDirectory(thisPlugin)

def showSeries(urlS):
	global thisPlugin

	content = getUrl(urlS)
	meta = re.compile(n_regexMeta,re.DOTALL).findall(content)
	print "[phr] --- MetaData"
	print meta

	vars = re.compile(regexTabVars,re.DOTALL).search(content)
	
	if vars:
		tabVars = "&xajaxargs[]="+vars.group(1)+"&xajaxargs[]="+vars.group(2)+"&xajaxargs[]="+vars.group(3)+"&xajaxargs[]="+vars.group(4)+"&xajaxargs[]="+vars.group(5)+"&xajax=show_top_and_movies&xajaxr="+str(time.time()).replace('.','')
		tabentries = re.compile(regexTabEntry,re.DOTALL).findall(vars.group(6))
		content = ""
		
		for te in tabentries:
			ajcon = postUrl(urlHost+ajaxUrl,"xajaxargs[]="+te+tabVars);
			content += ajcon;

	match = re.compile(regexSeries,re.DOTALL).findall(content)
	print match
	for m in match:
		print m
		if "kostenlos" in m[4]:
			date = remHTML(m[3])
			if date == "232.000x":
				date = ""
			else:
				date = " - " + date
			title = decode_htmlentities(m[2]) + date
			metatext = title.encode("UTF-8") + " : "+decode_htmlentities(meta[0][0])
			print "[phr] -- metatext: "+metatext
			#decode_htmlentities(title + " - " + meta[0][0])
			addPlayableItem(title, {"urlV": m[1], "vidN": m[2]},meta[0][1], metatext)
	print "--- showSeries ok"	
	xbmcplugin.endOfDirectory(thisPlugin)

def showVideo(urlV, vidN):
	print "--- showVideo"
	global thisPlugin
	print "--- "+urlV
	content = getUrl(urlV)
	#print content
	match=re.compile(regexVideoData).findall(content)
	xmlUrl = urlHost+urllib.unquote(match[0])
	print "--- "+xmlUrl
	contentB = getUrl(xmlUrl)
	print contentB
	
	# subDaten
	matchPageUrl = re.compile(pageUrlRegex).findall(content)
	print "-- pageUrl - "+matchPageUrl[0]
	matchIVW = re.compile("ivw=(.*?)&").findall(xmlUrl)
	print matchIVW
	matchTimeType = re.compile("<timetype>(.*?)</timetype>").findall(contentB)
	matchFkContent = re.compile("<fkcontent>(.*?)</fkcontent>").findall(contentB)
	matchSeason = re.compile("<season>(.*?)</season>").findall(contentB)
	matchSession = "2289727260"
	matchUser = "2880224004"
	# subDaten Ende
	
	matchfilename = re.compile(regexXML).findall(contentB)
	splitted = matchfilename[0].split('/')
	if matchfilename[0].find(".f4v.f4m?ts=") != -1:
		f4mXML = getUrl(matchfilename[0])
		#print f4mXML
		videoReged = re.compile(regexF4mVideo).findall(matchfilename[0])
		print "[phr] -- found f4m videourl: "+videoReged[0]
		videoUrl = "rtmpe://fms-fra"+str(random.randint(1, 20))+".rtl.de/rtlnow/"
		playpath = "mp4:"+videoReged[0]
		
	else:
		print "[phr] -- found flv videourl: "+ matchfilename[0]
		splitted = matchfilename[0].split('/')
		print splitted
		# -----
		videoUrl=splitted[0]+"//"+splitted[2]+"/"+splitted[3]+"/"
		videoUrlB=splitted[2]+"/"+splitted[3]+"/"
		addpre=""	
		if splitted[5][-4:-1] == ".f4":
			addpre="mp4:"
		if splitted[5][-4:-1] == ".fl":
			splitted[5]=splitted[5][0:-4]
		playpath = addpre+splitted[4]+"/"+splitted[5]

	appData = "voxnow"
	swfUrl = "http://www.voxnow.de/includes/vodplayer.swf"
	pageUrl = urlHost+"/"+matchPageUrl[0]
	
	cPlayPath = playpath+"?ivw=/"+matchIVW[0]+"&client=videoplayer&type=content&user=2880224004&session=2289727260&angebot=voxnow&starttime=00:00:00:00&timetype="+matchTimeType[0]+"&fkcontent="+matchFkContent[0]+"&season="+matchSeason[0]
	print "-- swfUrl - "+swfUrl
	print "-- PlayPath - "+cPlayPath
	print "-- app - "+appData
	#print "-- tcUrl - "+tcUrl
	#print "-- videoUrl - "+videoUrl
	print "-- pageUrl - "+pageUrl
	
	fullData = videoUrl+' swfVfy=1 playpath='+cPlayPath+' app='+appData+'/ pageUrl='+pageUrl+'/ tcUrl='+videoUrl+' swfUrl='+swfUrl 
	print "------------"
	print "-- fullData - "+fullData
	print "------------"
	listitem = xbmcgui.ListItem(path=fullData)
	return xbmcplugin.setResolvedUrl(thisPlugin, True, listitem)

# ------ helper ------

def returnBiggerPic(picUrl):
	#matchPic = re.compile("(.*?format/)(.*?)(/format.*?)",re.DOTALL).findall(m[0])
	#if !matchPic:
	matchPic = re.compile(regexBiggerPic,re.DOTALL).findall(picUrl)
	Res = matchPic[0][1].split("x")
	resx = int(Res[0])*3
	resy = int(Res[1])*3
	newUrl = matchPic[0][0]+str(resx)+"x"+str(resy)+matchPic[0][2]+matchPic[0][3]
	return newUrl

	
def remHTML(text):
	result = re.compile(regexTextOnly,re.DOTALL).sub('',text)
	return result

def postUrl(url, values):
    req = urllib2.Request(url)
    response = urllib2.urlopen(req, values)
    link=response.read()
    response.close()
    return link

def getUrl(url):
	req = urllib2.Request(url)
	req.add_header('User-Agent', 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3')
	response = urllib2.urlopen(req)
	link=response.read()
	response.close()
	return link

def addDirectoryItem(name, parameters={},pic=""):
    li = xbmcgui.ListItem(name,iconImage="DefaultFolder.png", thumbnailImage=pic)
    url = sys.argv[0] + '?' + urllib.urlencode(parameters)
    return xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]), url=url, listitem=li, isFolder=True)
	
def addPlayableItem(name, parameters={}, pic="", desc=""):
    li = xbmcgui.ListItem(name,iconImage="DefaultFolder.png", thumbnailImage=pic)
    li.setInfo( type="Video", infoLabels={ "Title": name, "Plot" : desc, "PlotOutline":desc, "Label":desc } )
    li.setProperty('IsPlayable', 'true')
    url = sys.argv[0] + '?' + urllib.urlencode(parameters)
    return xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]), url=url, listitem=li, isFolder=False)
	
	
def parameters_string_to_dict(parameters):
    ''' Convert parameters encoded in a URL to a dict. '''
    paramDict = {}
    if parameters:
        paramPairs = parameters[1:].split("&")
        for paramsPair in paramPairs:
            paramSplits = paramsPair.split('=')
            if (len(paramSplits)) == 2:
                paramDict[paramSplits[0]] = paramSplits[1]
    return paramDict

def substitute_entity(match):
    ent = match.group(3)
    
    if match.group(1) == "#":
        if match.group(2) == '':
            return unichr(int(ent))
        elif match.group(2) == 'x':
            return unichr(int('0x'+ent, 16))
    else:
        cp = n2cp.get(ent)

        if cp:
            return unichr(cp)
        else:
            return match.group()

def decode_htmlentities(string):
    entity_re = re.compile(r'&(#?)(x?)(\w+);')
    return entity_re.subn(substitute_entity, string)[0]

# ----- main -----

params = parameters_string_to_dict(sys.argv[2])
urlSeries = str(params.get("urlS", ""))
urlVideo = str(params.get("urlV", ""))
vidName = str(params.get("vidN", ""))

if not sys.argv[2]:
	# new start
	ok = showContent()
else:
	if urlSeries:
		newUrl = urlHost + urllib.unquote(urlSeries)
		print newUrl
		ok = showSeries(newUrl)
	if urlVideo:
		newUrl = urlHost + decode_htmlentities(urllib.unquote(urlVideo))
		print newUrl
		ok = showVideo(newUrl, decode_htmlentities(urllib.unquote_plus(vidName)))